"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SpinnerDownloading = void 0;

var _react = _interopRequireDefault(require("react"));

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _PlayForWork = _interopRequireDefault(require("@material-ui/icons/PlayForWork"));

var _styles = require("@material-ui/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = function useStyles(spinnerSize) {
  return (0, _styles.makeStyles)({
    spinnerIcon: {
      width: spinnerSize,
      height: spinnerSize
    },
    spinnerWrapper: {
      width: spinnerSize,
      position: 'relative',
      margin: 'auto'
    },
    fabProgress: {
      color: "primary",
      position: 'absolute',
      left: 0,
      zIndex: 1
    }
  })();
};

var SpinnerDownloading = function SpinnerDownloading(_ref) {
  var spinnerSize = _ref.spinnerSize,
      style = _ref.style,
      loading = _ref.loading,
      children = _ref.children;
  var classes = useStyles(spinnerSize);
  return children === undefined || loading ? /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.spinnerWrapper,
    style: _objectSpread({}, style)
  }, /*#__PURE__*/_react["default"].createElement(_PlayForWork["default"], {
    color: "secondary",
    className: classes.spinnerIcon
  }), /*#__PURE__*/_react["default"].createElement(_CircularProgress["default"], {
    size: spinnerSize,
    className: classes.fabProgress
  })) : children;
};

exports.SpinnerDownloading = SpinnerDownloading;