"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getObjectJoin = exports.getObjectValue = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var getObjectValue = function getObjectValue(targetObject, fieldName) {
  if (fieldName) {
    var childFields = fieldName.split('.'); //get to the property value by iterating through the object structure

    var propValue = targetObject;

    for (var index in childFields) {
      // noinspection JSUnfilteredForInLoop
      propValue = propValue[childFields[index]];
    }

    return propValue === undefined || propValue === null ? "" : propValue;
  } else return targetObject === undefined || targetObject === null ? "" : targetObject;
};

exports.getObjectValue = getObjectValue;

var getObjectJoin = function getObjectJoin(targetObject) {
  return targetObject && Object.values(targetObject).map(function (item) {
    return _typeof(item) === "object" ? getObjectJoin(item) : item;
  }).join() || "";
};

exports.getObjectJoin = getObjectJoin;