"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "TablePaging", {
  enumerable: true,
  get: function get() {
    return _TablePaging.TablePaging;
  }
});
Object.defineProperty(exports, "TableSkeletonPaging", {
  enumerable: true,
  get: function get() {
    return _TableSkeletonPaging.TableSkeletonPaging;
  }
});
exports.mockUsers = exports.TableDemo = exports.headerConfig = void 0;

var _react = _interopRequireDefault(require("react"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _TablePaging = require("./tableStandard/TablePaging");

var _TableSkeletonPaging = require("./tableStandard/TableSkeletonPaging");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function () { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var headerConfig = {
  key: "id",
  itemsPerPage: 8,
  defaultSort: "firstName",
  columns: [{
    fieldForSort: "id",
    columnLabel: "Id",
    headerCellStyle: {
      width: 80
    },
    hideWhenCondensed: true
  }, {
    fieldForSort: "firstName",
    columnLabel: "Name First",
    headerCellStyle: {
      width: 120
    },
    disableCellClick: true
  }, {
    fieldForSort: "lastName",
    columnLabel: "Name Last",
    headerCellStyle: {
      width: 120
    }
  }, {
    fieldForSort: "location.city",
    columnLabel: "Location"
  }, {
    display: function display(row) {
      return "".concat(row.lastName, ", ").concat(row.firstName);
    },
    columnLabel: "Full Name"
  }]
};
exports.headerConfig = headerConfig;

var TableDemo = /*#__PURE__*/function (_React$Component) {
  _inherits(TableDemo, _React$Component);

  var _super = _createSuper(TableDemo);

  function TableDemo() {
    var _this;

    _classCallCheck(this, TableDemo);

    _this = _super.call(this); //this.timeOut = this.timeOut.bind(this);

    _defineProperty(_assertThisInitialized(_this), "state", {
      loading: true,
      users: mockUsers,
      filterText: "",
      removeStyling: true,
      selectedUser: null
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (name, value) {
      _this.setState(_defineProperty({}, name, value));
    });

    _defineProperty(_assertThisInitialized(_this), "handleRowClick", function (user) {
      // noinspection JSCheckFunctionSignatures
      _this.setState({
        selectedUser: user
      });
    });

    return _this;
  }

  _createClass(TableDemo, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        return _this2.timeOut();
      }, 2000);
    }
  }, {
    key: "searchName",
    value: function searchName(itemList) {
      var filterText = this.state.filterText;
      return itemList.filter(function (user) {
        return user.firstName.toLowerCase().indexOf(filterText.toLowerCase()) > -1;
      });
    }
  }, {
    key: "timeOut",
    value: function timeOut() {
      // noinspection JSCheckFunctionSignatures
      this.setState({
        loading: false
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state = this.state,
          loading = _this$state.loading,
          users = _this$state.users,
          filterText = _this$state.filterText,
          removeStyling = _this$state.removeStyling,
          selectedUser = _this$state.selectedUser;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          display: "flex"
        }
      }, /*#__PURE__*/_react["default"].createElement("h4", {
        style: {
          marginLeft: 20
        }
      }, "Table with Paging and Search"), /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        label: "Search",
        style: {
          marginLeft: 40
        },
        vaule: filterText,
        onChange: function onChange(event) {
          return _this3.handleChange("filterText", event.target.value);
        }
      }), /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], {
        style: {
          marginLeft: 10
        },
        control: /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: removeStyling,
          onChange: function onChange() {
            return _this3.setState({
              removeStyling: !removeStyling
            });
          },
          value: "checkedB",
          color: "primary"
        }),
        label: "Remove Styling"
      }), selectedUser === null && /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          marginTop: 21
        }
      }, " | Click on a Row"), selectedUser && /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          marginTop: 21
        }
      }, " | Selected ", selectedUser.firstName, " ", selectedUser.lastName)), /*#__PURE__*/_react["default"].createElement(_TablePaging.TablePaging, {
        loading: loading,
        dataList: users,
        headerConfig: headerConfig,
        filterText: filterText,
        tableStyleName: removeStyling ? "" : "stripe-table",
        onRowClick: function onRowClick(user) {
          return _this3.handleRowClick(user);
        },
        useMaterialUiPaging: true //searchFunction={(dataList) => this.searchName(dataList)}

      }));
    }
  }]);

  return TableDemo;
}(_react["default"].Component);

exports.TableDemo = TableDemo;
var mockUsers = [{
  "id": 9,
  "firstName": "Cassandra",
  "lastName": "Andrews",
  "location": {
    "city": "Dotsero"
  }
}, {
  "id": 1,
  "firstName": "Lakisha",
  "lastName": "Alvarez",
  "location": {
    "city": "Winfred"
  }
}, {
  "id": 2,
  "firstName": "Kathy",
  "lastName": "Fox",
  "location": {
    "city": "Gorst"
  }
}, {
  "id": 3,
  "firstName": "Cote",
  "lastName": "Haynes",
  "location": {
    "city": "Fairhaven"
  }
}, {
  "id": 4,
  "firstName": "Toni",
  "lastName": "Rose",
  "location": {
    "city": "Leroy"
  }
}, {
  "id": 5,
  "firstName": "Lauren",
  "lastName": "Clark",
  "location": {
    "city": "Marne"
  }
}, {
  "id": 6,
  "firstName": "Mckenzie",
  "lastName": "Davidson",
  "location": {
    "city": "Tetherow"
  }
}, {
  "id": 7,
  "firstName": "Mallory",
  "lastName": "Roman",
  "location": {
    "city": "Sterling"
  }
}, {
  "id": 8,
  "firstName": "Walls",
  "lastName": "Mack",
  "location": {
    "city": "Onton"
  }
}, {
  "id": 0,
  "firstName": "Amie",
  "lastName": "Shepherd",
  "location": {
    "city": "Catherine"
  }
}, {
  "id": 10,
  "firstName": "Jewel",
  "lastName": "Wise",
  "location": {
    "city": "Rutherford"
  }
}, {
  "id": 11,
  "firstName": "Christina",
  "lastName": "Woodard",
  "location": {
    "city": "Websterville"
  }
}, {
  "id": 12,
  "firstName": "Nicole",
  "lastName": "Tillman",
  "location": {
    "city": "Beaulieu"
  }
}, {
  "id": 13,
  "firstName": "Robinson",
  "lastName": "Larsen",
  "location": {
    "city": "Benson"
  }
}, {
  "id": 14,
  "firstName": "Carissa",
  "lastName": "Hogan",
  "location": {
    "city": "Kenwood"
  }
}, {
  "id": 15,
  "firstName": "Garrett",
  "lastName": "Sutton",
  "location": {
    "city": "Torboy"
  }
}, {
  "id": 16,
  "firstName": "Beach",
  "lastName": "Abbott",
  "location": {
    "city": "Ruckersville"
  }
}, {
  "id": 17,
  "firstName": "Lacy",
  "lastName": "Bird",
  "location": {
    "city": "Belleview"
  }
}, {
  "id": 18,
  "firstName": "Misty",
  "lastName": "Cooley",
  "location": {
    "city": "Fowlerville"
  }
}];
exports.mockUsers = mockUsers;