"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableHeaderSort = void 0;

var _react = _interopRequireDefault(require("react"));

var _TableHead = _interopRequireDefault(require("@material-ui/core/TableHead"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _TableSortLabel = _interopRequireDefault(require("@material-ui/core/TableSortLabel"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var TableHeaderSort = function TableHeaderSort(_ref) {
  var headerConfig = _ref.headerConfig,
      sortField = _ref.sortField,
      sortDescending = _ref.sortDescending,
      onSetSortField = _ref.onSetSortField;
  return /*#__PURE__*/_react["default"].createElement(_TableHead["default"], null, /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, headerConfig.columns.map(function (config, index) {
    return /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
      key: index,
      style: config.headerCellStyle,
      className: sortField === config.fieldForSort ? "sorted" : ""
    }, config.fieldForSort ? /*#__PURE__*/_react["default"].createElement(_TableSortLabel["default"], {
      active: sortField === config.fieldForSort,
      direction: sortDescending ? "desc" : "asc",
      onClick: function onClick() {
        return onSetSortField(config.fieldForSort);
      }
    }, config.columnLabel) : /*#__PURE__*/_react["default"].createElement("span", null, config.columnLabel));
  })));
};

exports.TableHeaderSort = TableHeaderSort;