"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TablePagination = void 0;

var _react = _interopRequireDefault(require("react"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _Select = _interopRequireDefault(require("@material-ui/core/Select"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _FirstPage = _interopRequireDefault(require("@material-ui/icons/FirstPage"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _LastPage = _interopRequireDefault(require("@material-ui/icons/LastPage"));

var _PaginationStype = require("./PaginationStype");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var TablePagination = function TablePagination(_ref) {
  var pageList = _ref.pageList,
      pagingMessage = _ref.pagingMessage,
      currentPageNum = _ref.currentPageNum,
      onPageChange = _ref.onPageChange,
      showPrevButton = _ref.showPrevButton,
      showNextButton = _ref.showNextButton,
      allPages = _ref.allPages,
      hasPaging = _ref.hasPaging,
      condensed = _ref.condensed;
  var classes = (0, _PaginationStype.useStyles)();
  return hasPaging && /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.root
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.containerHalfLeft
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.pagingMessageContainer
  }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    className: classes.pagingMessage
  }, condensed ? /*#__PURE__*/_react["default"].createElement("span", null, " ", pagingMessage, " Go to :") : /*#__PURE__*/_react["default"].createElement("span", null, "Showing ", pagingMessage, " records,  Go to :"))), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.pagingMessageContainer
  }, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], null, /*#__PURE__*/_react["default"].createElement(_Select["default"], {
    className: classes.formControl,
    "native": true,
    value: currentPageNum,
    onChange: function onChange(event) {
      return onPageChange(parseInt(event.target.value));
    }
  }, allPages.map(function (pageNum, index) {
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: index,
      value: pageNum
    }, pageNum);
  }))))), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.containerHalfRight
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.pageButtonsContainer
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    disabled: !showPrevButton,
    className: classes.pageButtonEndLeft,
    onClick: function onClick() {
      return onPageChange(1);
    }
  }, /*#__PURE__*/_react["default"].createElement(_FirstPage["default"], {
    className: classes.pageButtonsIconsText,
    fontSize: "small"
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.pageButtonsContainer
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    disabled: !showPrevButton,
    className: classes.pageButton,
    onClick: function onClick() {
      return onPageChange(currentPageNum - 1);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ChevronLeft["default"], {
    className: classes.pageButtonsIconsText,
    fontSize: "small"
  }))), pageList.map(function (page, index) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: index,
      className: classes.pageButtonsContainer
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      className: classes.pageButton,
      onClick: function onClick() {
        return onPageChange(page);
      },
      id: "pageNumButton-".concat(index),
      color: "primary",
      style: {
        backgroundColor: page === currentPageNum ? "#428bca" : "",
        color: page === currentPageNum ? "white" : ""
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: classes.pageButtonsText
    }, page)));
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.pageButtonsContainer
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    disabled: !showNextButton,
    className: classes.pageButton,
    onClick: function onClick() {
      return onPageChange(currentPageNum + 1);
    }
  }, /*#__PURE__*/_react["default"].createElement(_ChevronRight["default"], {
    className: classes.pageButtonsIconsText,
    fontSize: "small"
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.pageButtonsContainer
  }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
    disabled: !showNextButton,
    className: classes.pageButtonEndRight,
    onClick: function onClick() {
      return onPageChange(true);
    }
  }, /*#__PURE__*/_react["default"].createElement(_LastPage["default"], {
    className: classes.pageButtonsIconsText,
    fontSize: "small"
  })))));
};

exports.TablePagination = TablePagination;