"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tableRows = exports.TablePaging = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SpinnerDownloading = require("../extras/SpinnerDownloading");

var _TableSkeletonPaging = require("./TableSkeletonPaging");

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _styles = require("@material-ui/core/styles");

var _TableHeaderSort = require("./TableHeaderSort");

var _pagingCalc = require("../helpers/pagingCalc");

var _objectValue = require("../helpers/objectValue");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var TablePaging = function TablePaging(_ref) {
  var loading = _ref.loading,
      dataList = _ref.dataList,
      headerConfig = _ref.headerConfig,
      filterText = _ref.filterText,
      tableStyleName = _ref.tableStyleName,
      searchFunction = _ref.searchFunction,
      onRowClick = _ref.onRowClick,
      condensed = _ref.condensed,
      onServerSidePaging = _ref.onServerSidePaging,
      totalRecordsFromServer = _ref.totalRecordsFromServer,
      restPageNumber = _ref.restPageNumber,
      useMaterialUiPaging = _ref.useMaterialUiPaging;
  var roundToNearest5 = Math.round((headerConfig.itemsPerPage || 10) / 5) * 5;

  var _useState = (0, _react.useState)(roundToNearest5),
      _useState2 = _slicedToArray(_useState, 2),
      itemsPerPage = _useState2[0],
      setItemsPerPage = _useState2[1];

  var _useState3 = (0, _react.useState)(headerConfig.defaultSort || headerConfig.columns[0].fieldForSort),
      _useState4 = _slicedToArray(_useState3, 2),
      sortField = _useState4[0],
      setSortField = _useState4[1];

  var _useState5 = (0, _react.useState)(headerConfig.sortDescending || false),
      _useState6 = _slicedToArray(_useState5, 2),
      sortDescending = _useState6[0],
      setSortDescending = _useState6[1];

  var _useState7 = (0, _react.useState)(1),
      _useState8 = _slicedToArray(_useState7, 2),
      activePage = _useState8[0],
      setActivePage = _useState8[1];

  var filterTextLower = filterText && filterText.toLowerCase();
  (0, _react.useEffect)(function () {
    if (restPageNumber > 0) setActivePage(restPageNumber);
  }, [restPageNumber]);
  var filteredList = [];

  if (filterText && filterText.length > 0) {
    filteredList = searchFunction ? searchFunction(dataList) : dataList.filter(function (item) {
      return item && (0, _objectValue.getObjectJoin)(item).toLowerCase().indexOf(filterTextLower) > -1; //.indexOf(filterText.toLowerCase()) > -1;
    });
  } else {
    filteredList = _toConsumableArray(dataList);
  }

  var onSetSortField = function onSetSortField(newSortField) {
    var isDescending = newSortField === sortField && !sortDescending;
    setSortDescending(isDescending);
    setSortField(newSortField);
    if (onServerSidePaging) onServerSidePaging({
      sortField: newSortField,
      sortDescending: isDescending,
      itemsPerPage: itemsPerPage,
      activePage: activePage
    });
  };

  var onPageChange = function onPageChange(newPage, newItemsPerPage) {
    setActivePage(newPage);
    if (newItemsPerPage > 0) setItemsPerPage(newItemsPerPage);
    if (onServerSidePaging) onServerSidePaging({
      sortField: sortField,
      sortDescending: sortDescending,
      itemsPerPage: itemsPerPage,
      activePage: newPage
    });
  };

  if (!onServerSidePaging) (0, _pagingCalc.sortItems)(filteredList, sortField, sortDescending);
  var paging = (0, _pagingCalc.calcPage)(filteredList, itemsPerPage, activePage, totalRecordsFromServer);

  var tableHeader = /*#__PURE__*/_react["default"].createElement(_TableHeaderSort.TableHeaderSort, {
    headerConfig: headerConfig,
    sortField: sortField,
    sortDescending: sortDescending,
    onSetSortField: onSetSortField
  });

  return /*#__PURE__*/_react["default"].createElement(_SpinnerDownloading.SpinnerDownloading, {
    spinnerSize: 50,
    loading: loading
  }, /*#__PURE__*/_react["default"].createElement(_TableSkeletonPaging.TableSkeletonPaging, {
    paging: paging,
    tableRows: tableRows(headerConfig, onRowClick),
    tableHeader: tableHeader,
    condensed: condensed,
    onPageChange: onPageChange,
    tableStyleName: tableStyleName,
    useMaterialUiPaging: useMaterialUiPaging || false
  }));
};

exports.TablePaging = TablePaging;
TablePaging.propTypes = {
  loading: _propTypes["default"].bool,
  dataList: _propTypes["default"].array.isRequired,
  headerConfig: _propTypes["default"].object.isRequired,
  filterText: _propTypes["default"].string,
  tableStyleName: _propTypes["default"].string,
  searchFunction: _propTypes["default"].func,
  onRowClick: _propTypes["default"].func,
  condensed: _propTypes["default"].bool
};

var tableRows = function tableRows(headerConfig, onItemClick) {
  var classes = useStyles();

  var _useState9 = (0, _react.useState)(null),
      _useState10 = _slicedToArray(_useState9, 2),
      selectedRowId = _useState10[0],
      setSelectedRowId = _useState10[1];

  var warningWasShown = false;

  var getValue = function getValue(row, header, onSelectRow) {
    var hasValue = !!(header.display || header.fieldForSort);

    if (!(warningWasShown || hasValue)) {
      console.warn("Column \"".concat(header.columnLabel, "\" must have a \"display\" or \"fieldSort\" field"));
      warningWasShown = true;
    }

    return hasValue ? header.display ? header.display(row, header, onSelectRow) : header.fieldForSort !== undefined && (0, _objectValue.getObjectValue)(row, header.fieldForSort) : "";
  };

  var onSelectRow = function onSelectRow(row) {
    if (headerConfig.key) setSelectedRowId(row[headerConfig.key]);
    onItemClick(row);
  };

  return function (row, index) {
    var hasClick = !!onItemClick;
    /** @namespace header.cellStyle */

    return /*#__PURE__*/_react["default"].createElement(_TableRow["default"], {
      key: index,
      className: hasClick ? classes.rowWithClick : classes.rowWithoutClick
    }, headerConfig.columns.map(function (header, index) {
      return /*#__PURE__*/_react["default"].createElement(_TableCell["default"], {
        key: index,
        onClick: function onClick() {
          return hasClick && !header.disableCellClick ? onSelectRow(row) : undefined;
        },
        className: hasClick && !header.disableCellClick ? classes.cellWithClick : null,
        style: _objectSpread({
          fontSize: 14,
          backgroundColor: selectedRowId !== null && headerConfig.key && selectedRowId === row[headerConfig.key] && "#cfcdd1"
        }, header.cellStyle)
      }, /*#__PURE__*/_react["default"].createElement("span", null, getValue(row, header, onSelectRow)));
    }));
  };
}; //'&:hover': {


exports.tableRows = tableRows;
var useStyles = (0, _styles.makeStyles)({
  rowWithoutClick: {
    height: 39
  },
  rowWithClick: {
    height: 39,
    '&:hover': {
      backgroundColor: "#fafaf9"
    }
  },
  cellWithClick: {
    cursor: "pointer"
  }
});