"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableSkeletonPaging = void 0;

var _react = _interopRequireDefault(require("react"));

var _Table = _interopRequireDefault(require("@material-ui/core/Table"));

var _TableBody = _interopRequireDefault(require("@material-ui/core/TableBody"));

var _TableRow = _interopRequireDefault(require("@material-ui/core/TableRow"));

var _TableCell = _interopRequireDefault(require("@material-ui/core/TableCell"));

var _TablePagination = _interopRequireDefault(require("@material-ui/core/TablePagination"));

var _TablePagination2 = require("./TablePagination");

var _NoData = require("../extras/NoData");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var TableSkeletonPaging = function TableSkeletonPaging(_ref) {
  var tableHeader = _ref.tableHeader,
      tableRows = _ref.tableRows,
      paging = _ref.paging,
      tableStyleName = _ref.tableStyleName,
      onPageChange = _ref.onPageChange,
      condensed = _ref.condensed,
      useMaterialUiPaging = _ref.useMaterialUiPaging;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Table["default"], {
    className: tableStyleName
  }, tableHeader, /*#__PURE__*/_react["default"].createElement(_TableBody["default"], null, paging.rows.map(tableRows), paging.rows.length === 0 && /*#__PURE__*/_react["default"].createElement(_TableRow["default"], null, /*#__PURE__*/_react["default"].createElement(_TableCell["default"], null, /*#__PURE__*/_react["default"].createElement(_NoData.ListNoData, {
    dataCount: 0
  }))))), useMaterialUiPaging ? /*#__PURE__*/_react["default"].createElement(_TablePagination["default"], {
    rowsPerPageOptions: paging.rowsPerPageOptions,
    component: "div",
    rowsPerPage: paging.itemsPerPage,
    page: paging.currentPageNum - 1,
    count: paging.totalRows,
    onChangePage: function onChangePage(event, page) {
      onPageChange(page + 1);
    },
    onChangeRowsPerPage: function onChangeRowsPerPage(event) {
      var pages = parseInt(event.target.value, 10);
      onPageChange(1, pages);
    }
  }) : /*#__PURE__*/_react["default"].createElement(_TablePagination2.TablePagination, _extends({}, paging, {
    onPageChange: onPageChange,
    condensed: condensed
  })));
};

exports.TableSkeletonPaging = TableSkeletonPaging;